' Really simple demonstration of interfacing the Intellivision Synth
' to IntyBASIC with a small external assembly routine.
'
' This demo doesn't play any music.  Rather, it simply fills 3 rows of
' the screen with squares indicating which of the 49 synth keys are
' currently pressed.
'
' J. Zbiciak, 2015
' Hereby released to the public domain.

            CONST   syn_key_addr = $47F4
            DEF FN  syn_key = PEEK( syn_key_addr )

            ASM     INCLUDE "scan_syn.asm"

            'CLS

            ' Initialize the synthesizer code.
            ASM     CALL    INIT_SYN        ;' clear all the state vars

            RESTORE my_syn_dn
            ASM     MVI     _read, R0       ;'\   Call 'my_syn_dn' for
            ASM     MVO     R0, SYNDN       ;' |_ key-down events.  The key
            ASM     SWAP    R0              ;' |  pressed is in syn_key
            ASM     MVO     R0, SYNDN+1     ;'/

            RESTORE my_syn_up
            ASM     MVI     _read, R0       ;'\   Call 'my_syn_up' for
            ASM     MVO     R0, SYNUP       ;' |_ key-up events.  The key
            ASM     SWAP    R0              ;' |  released is in syn_key
            ASM     MVO     R0, SYNUP+1     ;'/

            ' For this simple demo, just keep repeatedly scanning the
            ' synthesizer keyboard

forever:    ASM     CALL    SCAN_SYN
            GOTO    forever


            ' On key-down, go put a '#' on the screen according to the
            ' key number.  Keys 0-15 go in row 5, keys 16-31 go in row 6
            ' and keys 32-48 go in row 7.
jz_syn_dn:  PROCEDURE
            ofs = syn_key
            IF ofs >= 32 THEN ofs = ofs + 4
            IF ofs >= 16 THEN ofs = ofs + 4
            PRINT AT ofs + 102 COLOR 7, "#"
            END

            ' On key-up, go put a ' ' on the screen according to the
            ' key number.  Keys 0-15 go in row 5, keys 16-31 go in row 6
            ' and keys 32-48 go in row 7.
jz_syn_up:  PROCEDURE
            ofs = syn_key
            IF ofs >= 32 THEN ofs = ofs + 4
            IF ofs >= 16 THEN ofs = ofs + 4
            PRINT AT ofs + 102 COLOR 0, " "
            END
