        INCLUDE "constants.bas"

        ' The text colour when a key goes up or down, eh.
        CONST COLOUR_UNPRESSED = CS_YELLOW
        CONST COLOUR_DN = CS_WHITE
        CONST COLOUR_UP = CS_GREEN

        ' Change this to 1 if you want to print additional information.
        CONST PRINT_INFO = 1

        ' We use up to 8 MOBs to highlight the keys that are pressed down.
        CONST NUM_MOBS = 8
        CONST NUM_KEYS = 49
        CONST NO_KEY = 50
        dim mob_key(NUM_MOBS)

        gosub init

        INCLUDE "synth.bas"

        init:   PROCEDURE
                gosub init_data
                gosub init_graphics
                END

        init_data:      PROCEDURE
                numDown = 0
                for i = 0 to NUM_MOBS-1
                        mob_key(i) = NO_KEY
                next i
                END

        init_graphics:  PROCEDURE
                'MODE synth_FB
        	MODE SCREEN_CS, STACK_BLACK, STACK_WHITE, STACK_BLACK, STACK_WHITE
        	WAIT
        	DEFINE 0,16,synth_bitmaps_0
        	WAIT
        	DEFINE 16,5,synth_bitmaps_1
        	WAIT
                DEFINE 32,4,pressed_bitmaps
                WAIT
        	SCREEN synth_cards,0,200,20,2
                WAIT

                print at 0 color 7, "  Synth Key Test V1 "

                for key = 0 to NUM_KEYS-1
                        row = (key / 7) + 2
                        col = (key % 7) * 3
                        print at screenpos(col, row) color COLOUR_UNPRESSED, <2>key
                next key

                if PRINT_INFO = 1 then gosub print_info
                END

        key_info:      PROCEDURE
                octave = key_dn / 12
                note = key_dn % 12
                if note = 1 or note = 3 or note = 6 or note = 8 or note = 10 then
                        #sprite = SPR34+SPR_BLACK
                else
                        #sprite = SPR32+SPR_GREY
                end if

                sprite_x = octave * 39 + x_octave(note) + 8
                END

        my_syn_dn:      PROCEDURE
                ' The original callback in synth.bas by J. Zbiciak
                'gosub jz_syn_dn

                key_dn = syn_key

                ' print text
                row = (key_dn / 7) + 2
                col = (key_dn % 7) * 3
                print at screenpos(col, row) color COLOUR_DN, <2>key_dn

                numDown = numDown + 1

                ' draw sprite (if one is available)
                for i = 0 to NUM_MOBS-1
                        if mob_key(i) = NO_KEY then
                                gosub key_info
                                sprite i, sprite_x+VISIBLE, 11*8+ZOOMY2+DOUBLEY, #sprite+BEHIND
                                mob_key(i) = key_dn
                                exit for
                        end if
                next i

                if PRINT_INFO = 1 then gosub print_info
                END

        my_syn_up:      PROCEDURE
                ' The original callback in synth.bas by J. Zbiciak
                'gosub jz_syn_up

                key_up = syn_key

                row = (key_up / 7) + 2
                col = (key_up % 7) * 3
                print at screenpos(col, row) color COLOUR_UP, <2>key_up

                numDown = numDown - 1

                for i = 0 to NUM_MOBS-1
                        if mob_key(i) = key_up then
                                sprite i, 0
                                mob_key(i) = NO_KEY
                                exit for
                        end if
                next i

                if PRINT_INFO = 1 then gosub print_info
                END

        print_info:      PROCEDURE
                print at 20 color CS_TAN, "# depressed keys: ", <2>numDown
                END

	' 21 bitmaps
synth_bitmaps_0:
	BITMAP "00001010"
	BITMAP "00001010"
	BITMAP "00001010"
	BITMAP "00001010"
	BITMAP "00001010"
	BITMAP "00001010"
	BITMAP "00001010"
	BITMAP "00001010"

	BITMAP "00101000"
	BITMAP "00101000"
	BITMAP "00101000"
	BITMAP "00101000"
	BITMAP "00101000"
	BITMAP "00101000"
	BITMAP "00101000"
	BITMAP "00101000"

	BITMAP "10001010"
	BITMAP "10001010"
	BITMAP "10001010"
	BITMAP "10001010"
	BITMAP "10001010"
	BITMAP "10001010"
	BITMAP "10001010"
	BITMAP "10001010"

	BITMAP "10100010"
	BITMAP "10100010"
	BITMAP "10100010"
	BITMAP "10100010"
	BITMAP "10100010"
	BITMAP "10100010"
	BITMAP "10100010"
	BITMAP "10100010"

	BITMAP "00010100"
	BITMAP "00010100"
	BITMAP "00010100"
	BITMAP "00010100"
	BITMAP "00010100"
	BITMAP "00010100"
	BITMAP "00010100"
	BITMAP "00010100"

	BITMAP "01010001"
	BITMAP "01010001"
	BITMAP "01010001"
	BITMAP "01010001"
	BITMAP "01010001"
	BITMAP "01010001"
	BITMAP "01010001"
	BITMAP "01010001"

	BITMAP "01000100"
	BITMAP "01000100"
	BITMAP "01000100"
	BITMAP "01000100"
	BITMAP "01000100"
	BITMAP "01000100"
	BITMAP "01000100"
	BITMAP "01000100"

	BITMAP "10001000"
	BITMAP "10001000"
	BITMAP "10001000"
	BITMAP "10001000"
	BITMAP "10001000"
	BITMAP "10001000"
	BITMAP "10001000"
	BITMAP "10001000"

	BITMAP "01000101"
	BITMAP "01000101"
	BITMAP "01000101"
	BITMAP "01000101"
	BITMAP "01000101"
	BITMAP "01000101"
	BITMAP "01000101"
	BITMAP "01000101"

	BITMAP "00010000"
	BITMAP "00010000"
	BITMAP "00010000"
	BITMAP "00010000"
	BITMAP "00010000"
	BITMAP "00010000"
	BITMAP "00010000"
	BITMAP "00010000"

	BITMAP "00001010"
	BITMAP "00001010"
	BITMAP "00001110"
	BITMAP "00000100"
	BITMAP "00000100"
	BITMAP "00000100"
	BITMAP "00000100"
	BITMAP "00000100"

	BITMAP "00101000"
	BITMAP "00101000"
	BITMAP "00111000"
	BITMAP "00010000"
	BITMAP "00010000"
	BITMAP "00010000"
	BITMAP "00010000"
	BITMAP "00010000"

	BITMAP "10001010"
	BITMAP "10001010"
	BITMAP "10001110"
	BITMAP "10000100"
	BITMAP "10000100"
	BITMAP "10000100"
	BITMAP "10000100"
	BITMAP "10000100"

	BITMAP "10100010"
	BITMAP "10100010"
	BITMAP "11100010"
	BITMAP "01000010"
	BITMAP "01000010"
	BITMAP "01000010"
	BITMAP "01000010"
	BITMAP "01000010"

	BITMAP "00010100"
	BITMAP "00010100"
	BITMAP "00011100"
	BITMAP "00001000"
	BITMAP "00001000"
	BITMAP "00001000"
	BITMAP "00001000"
	BITMAP "00001000"

	BITMAP "01010001"
	BITMAP "01010001"
	BITMAP "01110001"
	BITMAP "00100001"
	BITMAP "00100001"
	BITMAP "00100001"
	BITMAP "00100001"
	BITMAP "00100001"

synth_bitmaps_1:
	BITMAP "01010001"
	BITMAP "01010001"
	BITMAP "01110001"
	BITMAP "00100000"
	BITMAP "00100000"
	BITMAP "00100000"
	BITMAP "00100000"
	BITMAP "00100000"

	BITMAP "01000100"
	BITMAP "01000100"
	BITMAP "11000100"
	BITMAP "10000100"
	BITMAP "10000100"
	BITMAP "10000100"
	BITMAP "10000100"
	BITMAP "10000100"

	BITMAP "10100010"
	BITMAP "10100010"
	BITMAP "11100011"
	BITMAP "01000001"
	BITMAP "01000001"
	BITMAP "01000001"
	BITMAP "01000001"
	BITMAP "01000001"

	BITMAP "10001000"
	BITMAP "10001000"
	BITMAP "10001000"
	BITMAP "00001000"
	BITMAP "00001000"
	BITMAP "00001000"
	BITMAP "00001000"
	BITMAP "00001000"

	BITMAP "01000101"
	BITMAP "01000101"
	BITMAP "11000111"
	BITMAP "10000010"
	BITMAP "10000010"
	BITMAP "10000010"
	BITMAP "10000010"
	BITMAP "10000010"

pressed_bitmaps:
        BITMAP "11111000"
        BITMAP "11111000"
        BITMAP "11111000"
        BITMAP "11111000"
        BITMAP "11111000"
        BITMAP "11111000"
        BITMAP "11111000"
        BITMAP "11111000"

        BITMAP "11111000"
        BITMAP "11111000"
        BITMAP "11111000"
        BITMAP "11111000"
        BITMAP "11111000"
        BITMAP "11111000"
        BITMAP "11111000"
        BITMAP "11111000"

        BITMAP "10000000"
        BITMAP "10000000"
        BITMAP "10000000"
        BITMAP "10000000"
        BITMAP "10000000"
        BITMAP "10000000"
        BITMAP "10000000"
        BITMAP "10000000"

        BITMAP "10000000"
        BITMAP "10000000"
        BITMAP "00000000"
        BITMAP "00000000"
        BITMAP "00000000"
        BITMAP "00000000"
        BITMAP "00000000"
        BITMAP "00000000"


	REM 20x2 cards
synth_cards:
	DATA $2800,$0808,$0810,$0808,$0818,$0820,$0828,$0820,$0828,$0830,$0808,$0818,$0808,$0818,$0838,$0828,$0830,$0828,$0840,$0848
	DATA $0850,$0858,$0860,$0858,$0868,$0870,$0878,$0870,$0880,$0888,$0858,$0868,$0858,$0890,$0898,$0880,$0888,$0880,$08A0,$0848


        ' The 160 pixels across the screen are divided as follows:
        ' 4*(5+1+5+1+4+1+4+1+5+1+5+1+4+1)+4 = 160
        ' so the offsets of the notes on the first octave are as follows:
        ' 0, 6, 12, 17, 23, 29, 34 for the white keys
        '   5, 11,     22, 28, 33  for the black keys
x_octave:
        DATA $0000,$0005,$0006,$000B,$000C,$0010,$0015,$0016,$001B,$001C,$0021,$0022
